/*
 * event.cpp
 * Copyright 2005 Red Hat Inc., Durham, North Carolina.
 * All Rights Reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Authors:
 *     Steve Grubb <sgrubb@redhat.com>
 *     Junji Kanemaru <junji.kanemaru@linuon.com>
 */
#include "event.h"

/**
 * Constructors/Destructors
 */
Event::Event (const Event& evt) {
    this->prio = evt.prio;
}

Event::Event (const Value& v, Priority prio) : Value(v) {
    this->prio = prio;
}

Event::Event (size_t size, const void* ptr, Priority prio) 
        : Value(ValuePtr(size, ptr)) {
    this->prio = prio;
}

Event::Event (const std::string& str, Priority prio) 
        : Value(ValueString(str)) {
    this->prio = prio;
}

Event::Event (const char* str, Priority prio) : Value(ValueString(str)) {
    this->prio = prio;
}

/**
 * Methods
 */

