/*
 * filter.h
 * Copyright 2005 Red Hat Inc., Durham, North Carolina.
 * All Rights Reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Authors:
 *     Steve Grubb <sgrubb@redhat.com>
 */
#ifndef FILTER_H
#define FILTER_H
#include <string>
#include "activeobject.h"
#include "outputplugin.h"

/**
 * Class Filter
 * This class will have a default constructor that is private since this is not the intended creation technique. The proper use is to use a constructor that takes a reference to a OutputPlugin. This is because this class is a composite. An output method is always assigned to the filter.
 */
class Filter : public ActiveObject {
/**
 * Public stuff
 */
public:
	/**
	 * Fields
	 */
	/**
	 * 
	 */
	/**
	 * Constructors
	 */
	/**
	 * Empty Constructor
	 */
	Filter ( ) { }
	/**
	 * Accessor Methods
	 */
	/**
	 * Operations
	 */
	/**
	 * This method is called to give the event to the filter plugin
	 */
	void receive_event ();
		
	
/**
 * Protected stuff
 */
protected:
	/**
	 * Fields
	 */
	/**
	 * 
	 */
	/**
	 * Constructors
	 */
	/**
	 * Accessor Methods
	 */
	/**
	 * Operations
	 */
/**
 * Private stuff
 */
private:
	/**
	 * Fields
	 */
	/**
	 * The Filter class owns an instance of the Output plugin that it uses.
	 */
	 OutputPlugin *output;
	/**
	 * 
	 */
	/**
	 * Constructors
	 */
	/**
	 * Accessor Methods
	 */
	/**
	 * Get the value of output
	 * The Filter class owns an instance of the Output plugin that it uses.
	 * @return the value of output
	 */
	OutputPlugin &get_output ( );
		
	
	/**
	 * Set the value of output
	 * The Filter class owns an instance of the Output plugin that it uses.
	 * @param value the value of output
	 */
	void set_output (OutputPlugin &value );
		
	
	/**
	 * Operations
	 */
};
#endif //FILTER_H

